<template lang="pug">
div
  .q-pa-md
    q-dialog(v-model="showDialog")
      q-card
        q-table(title="Voter Details", :data="voterDetails", :columns="voterColumns", row-key="userId")
          template(v-slot:body="props")
            q-tr(:props="props")
              q-td(key="userName", :props="props") {{ props.row.userName }}
              q-td(key="userId", :props="props") {{ props.row.userId }}
              q-td(key="votingResult", :props="props") {{ props.row.votingResult }}
              q-td(key="spotlight", :props="props")
                q-btn(color="blue", label="Spotlight", @click="spotlightStudent(props.row)", size="sm", no-caps="")
        q-card-actions(align="right")
          q-btn(flat="", label="OK", color="primary", v-close-popup="")

    q-table(
      v-if="voteTypeName"
      :title="`Select ${voteTypeName.singular} for voting`",
      :data="votingItemData",
      :columns="columns",
      row-key="itemId",
      selection="single",
      :selected-rows-label="getSelectedRowsLabel"
      :selected.sync="selected",
      @update:selected="onSelection()"
    )
      template(v-slot:body="props")
        q-tr(:props="props")
          q-td
            q-checkbox(v-model="props.selected")
          q-td.itemNameText(key="itemName", :props="props") {{ props.row.itemName }}
          q-td(key="yes", :props="props") {{ props.row.voteTotals.yes || 0 }}
          q-td(key="no", :props="props") {{ props.row.voteTotals.no || 0 }}
          q-td(key="rating1", :props="props") {{ props.row.voteTotals.rating1 || 0 }}
          q-td(key="rating2", :props="props") {{ props.row.voteTotals.rating2 || 0 }}
          q-td(key="rating3", :props="props") {{ props.row.voteTotals.rating3 || 0 }}
          q-td(key="rating4", :props="props") {{ props.row.voteTotals.rating4 || 0 }}
          q-td(key="rating5", :props="props") {{ props.row.voteTotals.rating5 || 0 }}
          q-td(key="score", :props="props") {{ props.row.score }}
          q-td(key="manipulateVotes", :props="props")
            q-btn(@click="manipulateVote(props.row, 1)", color="white", text-color="primary", round="", label="+")
            q-btn(@click="manipulateVote(props.row, 0)", color="white", text-color="primary", round="", label="-")
          q-td(key="voterDetails", :props="props")
            q-btn(
              color="blue",
              label="View Details",
              :disable="viewDetailsDisabled(props.row)",
              @click="displayVoterDetails(props.row)",
              size="sm",
              no-caps=""
            )

  .q-pa-md.q-gutter-sm(style="max-width: 750px", v-if="voteTypeName")
    q-input(filled="", v-model="newItemName", :label="`Enter new ${voteTypeName.singular}`")
    q-btn(:label="`add new ${voteTypeName.singular}`", type="submit", color="primary", @click="addNewVotingItem")
    q-input(
      v-model.number="numOverlayItems",
      min="1",
      type="number",
      filled,
      :label="`How many ${voteTypeName.plural} do you want to display on the overlay?`"
    )
    q-btn(label="display on overlay", type="submit", color="primary", @click="displayOnOverlay")
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import { ZoomSenseClientFirebaseDB } from "@zoomsense/zoomsense-firebase";
import { defaultSubmissionName, Vote, VotingPluginConfig, VotingPluginMeeting } from "zoomsense-plugin-voting-common";

import { areVotesRatings, getVoteTypeName, getVotingItemData, VotingItemData } from "./votingUtils";

export default Vue.extend({
  name: "Dashboard",
  props: {
    firebase: {
      required: true,
      type: Object as PropType<ZoomSenseClientFirebaseDB>,
    },
    context: {
      required: false,
      type: Object as PropType<{ meetingId: string }>,
    },
  },
  data() {
    return {
      // Firebase-bound values
      meetingVotes: null as null | VotingPluginMeeting,
      votingConfig: null as null | VotingPluginConfig,
      // UI values
      voterDetails: [] as Vote[],
      showDialog: false,
      newItemName: "",
      numOverlayItems: "",
      selected: [] as VotingItemData[],
      voterColumns: [
        {
          name: "userName",
          required: true,
          label: "NAME",
          align: "left",
          field: (row: VotingItemData) => row.userName,
          format: (val: any) => `${val}`,
          sortOrder: "da",
        },
        { name: "userId", label: "USER ID", align: "center", field: "userId" },
        { name: "votingResult", label: "VOTING RESULT", align: "center", field: "votingResult" },
        { name: "spotlight", label: "SPOTLIGHT", align: "center" },
      ],
    };
  },

  computed: {
    voteTypeName(): undefined | { singular: string; plural: string } {
      if (this.votingConfig === null) {
        return undefined;
      }
      return getVoteTypeName(this.votingConfig);
    },

    votingItemData(): VotingItemData[] {
      if (!this.meetingVotes) {
        return [];
      }
      return getVotingItemData(this.meetingVotes);
    },

    columns(): any[] {
      if (!this.votingConfig || !this.voteTypeName) {
        return [];
      }

      const ratingType = areVotesRatings(this.votingConfig);

      return [
        {
          name: "itemName",
          required: true,
          label: this.voteTypeName.singular.toUpperCase(),
          align: "left",
          field: (row: VotingItemData) => row.itemName,
          format: (val: any) => `${val}`,
          sortOrder: "da",
        },
        ...(ratingType
          ? [
              {
                name: "rating1",
                label: "1",
                align: "center",
                field: (row: VotingItemData) => row.voteTotals.rating1 ?? 0,
              },
              {
                name: "rating2",
                label: "2",
                align: "center",
                field: (row: VotingItemData) => row.voteTotals.rating2 ?? 0,
              },
              {
                name: "rating3",
                label: "3",
                align: "center",
                field: (row: VotingItemData) => row.voteTotals.rating3 ?? 0,
              },
              {
                name: "rating4",
                label: "4",
                align: "center",
                field: (row: VotingItemData) => row.voteTotals.rating4 ?? 0,
              },
              {
                name: "rating5",
                label: "5",
                align: "center",
                field: (row: VotingItemData) => row.voteTotals.rating5 ?? 0,
              },
            ]
          : [
              { name: "yes", label: "YES", align: "center", field: (row: VotingItemData) => row.voteTotals.yes ?? 0 },
              { name: "no", label: "NO", align: "center", field: (row: VotingItemData) => row.voteTotals.no ?? 0 },
            ]),
        {
          name: "score",
          label: ratingType ? "AVERAGE SCORE" : "AGGREGATED SCORE",
          align: "center",
          field: (row: VotingItemData) => row.score,
        },
        { name: "manipulateVotes", label: "MANIPULATE VOTES", align: "center" },
        { name: "voterDetails", label: "VOTER DETAILS", align: "center" },
      ];
    },

    submissionName(): string {
      return this.votingConfig?.submissionName ?? defaultSubmissionName;
    },
  },

  async created() {
    await this.$typedRtdbBind(
      "votingConfig",
      this.firebase.ref(`config/${this.context.meetingId}/current/currentState/plugins/voting`)
    );
  },

  watch: {
    votingConfig: {
      immediate: true,
      async handler() {
        await this.$typedRtdbBind(
          "meetingVotes",
          this.firebase.ref(`data/plugins/voting/${this.context.meetingId}/${this.submissionName}`)
        );
      },
    },
    meetingVotes: {
      immediate: true,
      async handler() {
        const selectedItem = this.votingItemData.find((el) => el.itemId === this.meetingVotes?.currentItem);
        this.selected = selectedItem ? [selectedItem] : [];
      },
    },
  },

  methods: {
    getSelectedRowsLabel() {
      return ""
    },

    async onSelection() {
      const currentItemRef = this.firebase.ref(
        `data/plugins/voting/${this.context.meetingId}/${this.submissionName}/currentItem`
      );
      if (this.selected.length === 1) {
        await currentItemRef.set(this.selected[0]!.itemId);
      } else {
        await currentItemRef.remove();
      }
    },

    async addNewVotingItem() {
      if (this.newItemName) {
        await this.firebase.ref(`data/plugins/voting/${this.context.meetingId}/${this.submissionName}/items`).push({
          item: {
            itemName: this.newItemName,
            timestamp: Date.now(),
            userName: "Dashboard",
          },
        });

        this.newItemName = "";
      }
    },

    async displayOnOverlay() {
      let numOverlayItems = Number(this.numOverlayItems);
      if (numOverlayItems > 0) {
        await this.firebase
          .ref(`data/plugins/voting/${this.context.meetingId}/${this.submissionName}/numOverlayItems`)
          .set(numOverlayItems);
      }
    },

    async manipulateVote(row: VotingItemData, direction: number) {
      if (!this.votingConfig) {
        return;
      }
      const manipulationVotingResults = areVotesRatings(this.votingConfig) ? ["rating1", "rating5"] : ["no", "yes"];
      const votingResult = manipulationVotingResults[direction];
      if (votingResult === undefined) {
        return;
      }
      const antiVotingResult = manipulationVotingResults[1 - direction];
      // Remove previous manipulation, if any.
      const votes = this.meetingVotes?.items?.[row.itemId]?.votes ?? {};
      const tutorPrefix = "tutor-";
      const tutorPreviousUserIds = Object.keys(votes).filter((userId) => userId.startsWith(tutorPrefix));
      const toRemoveId = tutorPreviousUserIds.find((userId) => votes[userId]?.votingResult === antiVotingResult);
      const voteItemRef = this.firebase.ref(
        `data/plugins/voting/${this.context.meetingId}/${this.submissionName}/items/${row.itemId}/votes`
      );
      if (toRemoveId) {
        // Remove a previous manipulation in the opposite direction.
        await voteItemRef.child(toRemoveId).remove();
      } else {
        // Add a vote in the positive direction.
        let tutorUserId = "";
        do {
          tutorUserId = `${tutorPrefix}${Math.round(Math.random() * 10000)}`;
        } while (tutorPreviousUserIds.includes(tutorUserId));
        await voteItemRef.child(tutorUserId).set({
          timestamp: Date.now(),
          userName: "TUTOR",
          votingResult,
        });
      }
    },

    viewDetailsDisabled(row: VotingItemData) {
      return this.meetingVotes?.items?.[row.itemId]?.votes === undefined;
    },

    displayVoterDetails(row: VotingItemData) {
      const votes = this.meetingVotes?.items?.[row.itemId]?.votes;

      if (!votes || !this.votingConfig) {
        return;
      }

      if (areVotesRatings(this.votingConfig)) {
        // Each votingResult starts with the string "rating", so strip that off.
        const ratingLength = "rating".length;
        this.voterDetails = Object.values(votes).map(({ votingResult, ...vote }) => ({
          ...vote,
          votingResult: votingResult.substring(ratingLength),
        }));
      } else {
        this.voterDetails = Object.values(votes);
      }
      this.showDialog = true;
    },

    spotlightStudent(row: VotingItemData) {
      console.log(row.userName + " spotlighted");
    },
  },
});
</script>

<style lang="scss" scoped>
.itemNameText {
  white-space: initial;
}
</style>
